;;########################## BEGIN GPL LICENSE BLOCK #############################
;;    This file is part of Area51Raid.
;;
;;    Area51Raid is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    (at your option) any later version.
;;
;;    Area51Raid is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with Area51Raid.  If not, see <https://www.gnu.org/licenses/>.
;;
;;    Developed for the CPCRetrodev contest 2019 edition.
;;
;;    Developers                           Contact
;;    = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
;;    Aguirre Ivorra, Antonio              antoni.aguirre@gmail.com
;;    López Gutiérrez, Juan Carlos         juancarlos.logut@gmail.com
;;    Pérez Ponsoda, Jorge Amil            j.a.perez.ponsoda@gmail.com
;;
;;########################### END GPL LICENSE BLOCK #############################

;;
;; MAIN
;;

.include "cpctelera.h.s"
.include "cpct_functions.h.s"
.include "man/game.h.s"
;; HANDLER
.include "man/handler.h.s"

.area _DATA
.area _CODE

_main::
;; Cambiamos la direccion de inicio de la pila
    ld  sp, #0x8000

    ld   de, #_song_game
    call cpct_akp_musicInit_asm

;; Inicializamos el manejador de interrupciones
    call set_init_handler

;;============================================================================
;; Inicializamos sistemas y manejadores
    call  game_man_init
    
;;============================================================================
;; Llamada para iniciar el juego
    call  start_game