;;########################## BEGIN GPL LICENSE BLOCK #############################
;;    This file is part of Area51Raid.
;;
;;    Area51Raid is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    (at your option) any later version.
;;
;;    Area51Raid is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with Area51Raid.  If not, see <https://www.gnu.org/licenses/>.
;;
;;    Developed for the CPCRetrodev contest 2019 edition.
;;
;;    Developers                           Contact
;;    = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
;;    Aguirre Ivorra, Antonio              antoni.aguirre@gmail.com
;;    López Gutiérrez, Juan Carlos         juancarlos.logut@gmail.com
;;    Pérez Ponsoda, Jorge Amil            j.a.perez.ponsoda@gmail.com
;;
;;########################### END GPL LICENSE BLOCK #############################


;;
;; HANDLER MANAGER
;;

.module handler_manager

.include "cpctelera.h.s"
.include "cpct_functions.h.s"

counter: .db  03

init_handler::
    push af
    push bc
    push de
    push hl

    ld   a, (counter)
    dec  a
    jr  nz, _cont

_zero:
    ;cpctm_setBorder_asm  HW_BRIGHT_WHITE
    call cpct_akp_musicPlay_asm
    call cpct_scanKeyboard_if_asm
    ld   a, #6

_cont:
    ld  (counter), a

    ;ld   h, a
    ;ld   l, #16
    ;call cpct_setPALColour_asm

    pop  hl
    pop  de
    pop  bc
    pop  af

    ei
    reti


set_init_handler::
    call cpct_waitVSYNC_asm
    halt
    halt
    call cpct_waitVSYNC_asm

    ld  hl, #0x38
    ld  (hl), #0xC3
    inc hl
    ld  (hl), #<init_handler
    inc hl
    ld  (hl), #>init_handler
    inc hl
    ld  (hl), #0xC9
    
    ret