;;########################## BEGIN GPL LICENSE BLOCK #############################
;;    This file is part of Area51Raid.
;;
;;    Area51Raid is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    (at your option) any later version.
;;
;;    Area51Raid is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with Area51Raid.  If not, see <https://www.gnu.org/licenses/>.
;;
;;    Developed for the CPCRetrodev contest 2019 edition.
;;
;;    Developers                           Contact
;;    = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
;;    Aguirre Ivorra, Antonio              antoni.aguirre@gmail.com
;;    López Gutiérrez, Juan Carlos         juancarlos.logut@gmail.com
;;    Pérez Ponsoda, Jorge Amil            j.a.perez.ponsoda@gmail.com
;;
;;########################### END GPL LICENSE BLOCK #############################



;;
;; INPUT SYSTEM
;;
.include "cpctelera.h.s"
.include "cpct_functions.h.s"
.include "man/entity.h.s"
.include "cmp/entity.h.s"
.include "sys/projectile.h.s"

.module input_system

input_sys_init::
    call entity_man_getArray
    ld (_ent_array_ptr), hl
    ret


;;  INPUT:
;;      IX: Pointer to the player
;;  DESTROY:
;;      AF, BC, DE, HL
input_sys_update::
_ent_array_ptr = .+2
;; +2 porque ld ix, #0x0000 son 4 bits
;; repertorio extendido de instrucciones
    ld ix, #0x0000
    
    ld e_vx(ix), #0
    ld e_vy(ix), #0

    ;; Se comprueba si se ha pulsado alguna tecla
    call cpct_isAnyKeyPressed_f_asm

    jr   z, Any_pressed

    ld hl, #Key_O
    call cpct_isKeyPressed_asm

    jr  nz, Left_pressed

    ld hl, #Joy0_Left
    call cpct_isKeyPressed_asm

    jr   z, Left_not_pressed

Left_pressed:
    ld e_vx(ix), #-1

Left_not_pressed:

    ld hl, #Key_P
    call cpct_isKeyPressed_asm

    jr  nz, Right_pressed

    ld hl, #Joy0_Right
    call cpct_isKeyPressed_asm

    jr   z, Right_not_pressed

Right_pressed:
    ld e_vx(ix), #1

Right_not_pressed:

    ld hl, #Joy0_Up
    call cpct_isKeyPressed_asm

    jr  nz, Up_pressed

    ld hl, #Key_Q
    call cpct_isKeyPressed_asm

    jr   z, Up_not_pressed

Up_pressed:
    ld e_vy(ix), #-2

Up_not_pressed:

    ld hl, #Joy0_Down
    call cpct_isKeyPressed_asm

    jr  nz, Down_pressed

    ld hl, #Key_A
    call cpct_isKeyPressed_asm

    jr   z, Down_not_pressed

Down_pressed:
    ld e_vy(ix), #2

Down_not_pressed:


Any_pressed:

    ret
