;;########################## BEGIN GPL LICENSE BLOCK #############################
;;    This file is part of Area51Raid.
;;
;;    Area51Raid is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    (at your option) any later version.
;;
;;    Area51Raid is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with Area51Raid.  If not, see <https://www.gnu.org/licenses/>.
;;
;;    Developed for the CPCRetrodev contest 2019 edition.
;;
;;    Developers                           Contact
;;    = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
;;    Aguirre Ivorra, Antonio              antoni.aguirre@gmail.com
;;    López Gutiérrez, Juan Carlos         juancarlos.logut@gmail.com
;;    Pérez Ponsoda, Jorge Amil            j.a.perez.ponsoda@gmail.com
;;
;;########################### END GPL LICENSE BLOCK #############################

;;
;; PATROL SYSTEM
;;
.include "cpctelera.h.s"
.include "sys/patrol.h.s"
.include "cmp/entity.h.s"
.include "man/patrol.h.s"

.module patrol_system

patrol_01:
    .db 65, 140
    .db 30, 140
    .db 30, 30
    .db 65, 30
    .db patrol_invalid_move
    .dw patrol_01

patrol_02:
    .db 30, 140
    .db 30, 30
    .db 8, 30
    .db 8, 140
    .db patrol_invalid_move
    .dw patrol_02

patrol_03:
    .db 10, 40
    .db 56, 40
    .db patrol_invalid_move
    .dw patrol_03

patrol_04:
    .db 10, 80
    .db 56, 80
    .db patrol_invalid_move
    .dw patrol_04

;; 
;; GETTER
;;
patrol_sys_get::
    or a
    jr nz, _p2
_p1:
    ld hl, #patrol_01
    ret
_p2:
    dec a
    or a
    jr nz, _p3

    ld hl, #patrol_02
    ret
_p3:
    dec a
    or a
    jr nz, _p4
    
    ld hl, #patrol_03
    ret
_p4:
    ld hl, #patrol_04
    ret

;;
;; INIT
;;
patrol_sys_init::
    call patrol_man_getArrayHL
    ld (_ent_array_ptr), hl
    ret

;;
;; ACTUALIZAR
;;
patrol_sys_update::
_ent_array_ptr = .+1
    ld hl, #0x0000
    ld b, #0

_loop:
    ld e, (hl)
    inc hl
    ld d, (hl)
    inc hl

    ld a, e
    or d
    ret z

    ld__ixl_e
    ld__ixh_d

    ld a, b
    push hl

    call patrol_sys_get
    ld e_ai_patrol_step_l(ix), l
    ld e_ai_patrol_step_h(ix), h
    inc b

    pop hl
    jr _loop
