;;########################## BEGIN GPL LICENSE BLOCK #############################
;;    This file is part of Area51Raid.
;;
;;    Area51Raid is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    (at your option) any later version.
;;
;;    Area51Raid is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with Area51Raid.  If not, see <https://www.gnu.org/licenses/>.
;;
;;    Developed for the CPCRetrodev contest 2019 edition.
;;
;;    Developers                           Contact
;;    = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
;;    Aguirre Ivorra, Antonio              antoni.aguirre@gmail.com
;;    López Gutiérrez, Juan Carlos         juancarlos.logut@gmail.com
;;    Pérez Ponsoda, Jorge Amil            j.a.perez.ponsoda@gmail.com
;;
;;########################### END GPL LICENSE BLOCK #############################

.include "cpctelera.h.s"
.include "cpct_functions.h.s"
.include "cmp/entity.h.s"
.include "man/entity.h.s"
.include "sys/game_status.h.s"
.include "man/projectile.h.s"

.module projectile_system
;; la idea del projectile es que si 
;; si estoy en la misma columna o fila de y o x 
;; que un soldado este me dispare su proyectil
;; cada determinado tiempo, asegurandome que 
;;
;; 1ero: si el proyectil ha llegaod a un muro
;; el proyectil desaparece/no se renderiza

;; 2o: si ha pasado suficientetiempo/ tiempo establecido
;; vuelve a ser elegible para disparar.

;; comentario al princpio de la físicas

;; comentario en colisiones
projectile_sys_init::
    call projectile_man_getArrayHL
    ld (_ent_array_ptr), hl
    ret

projectile_sys_update::
    _ent_array_ptr = .+1
    ld hl, #0x0000
    
_loop:
    ld   e, (hl)
    inc hl
    ld   d, (hl)
    inc hl

    ld   a, e
    or   d
    ret z

    ld__ixl_e
    ld__ixh_d

    push hl
    
    ;; alcance como tiempo de vida de la bala
    ;; las fisicas se encargan de mover la bala, TODO que no reboten con los bordes
    ;; y las colisiones del resto
    ld  a,  e_ai_aim_x(ix)
    dec a
    jr  z,  _reset_bullet

    ld  e_ai_aim_x(ix),    a

    jr  _fin

_reset_bullet:
    call projectile_sys_reset_bullet
    
_fin:
    pop hl
    jr _loop

projectile_sys_reset_bullet::
;    ld__e_ixl
;    ld__d_ixh
;    push de
;    call entity_render_man_delete
;    pop de
;    push de
;    call projectile_man_delete
;    pop de
;    push de
;    call physics_man_delete
;    pop de
;    call collision_man_delete
    ld a, e_ai_st(ix)
    ld e_x(ix), a
    ld a, e_ai_pre_st(ix)
    ld e_y(ix), a
    ld a, #range
    ld e_ai_aim_x(ix), a
    ret

projectile_sys_reset_bulletY::
;    ld__e_iyl
;    ld__d_iyh
;    push de
;    call entity_render_man_delete
;    pop de
;    push de
;    call projectile_man_delete
;    pop de
;    push de
;    call physics_man_delete
;    pop de
;    call collision_man_delete
    ld a, e_ai_st(iy)
    ld e_x(iy), a
    ld a, e_ai_pre_st(iy)
    ld e_y(iy), a
    ld a, #range
    ld e_ai_aim_x(iy), a
    ret
